All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.metadata.remote
Interface Variable

All Superinterfaces:
  CMetadata, MdObjectBase, MdObjectBaseUtil, MdObjectBaseXML, java.rmi.Remote, Root, SecondaryType

    public interface Variable

extends SecondaryType

Used to define substitution strings and the replacement values.

Attributes of Variable are:

- `Marker`
- `ValueType`

Associations of Variable are:

- `AssociatedObject`
- `OwningTransformation`

## Usage

To create an instance of this Variable, use the `factory` create methods.
Example: create a Variable with name "Variable_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     Variable myObject = (Variable) factory.createComplexMetadataObject(objectStore, "Variable_Object", MetadataObjects.VARIABLE, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

Field Summary
`static java.lang.String` | `ASSOCIATION_ASSOCIATEDOBJECT_NAME` Constant used for the name of the AssociatedObject association.
`static java.lang.String` | `ASSOCIATION_OWNINGTRANSFORMATION_NAME` Constant used for the name of the OwningTransformation association.
`static java.lang.String` | `ATTRIBUTE_MARKER_NAME` Constant used for the name of the Marker attribute.
`static java.lang.String` | `ATTRIBUTE_VALUETYPE_NAME` Constant used for the name of the ValueType attribute.

Fields inherited from interface com.sas.metadata.remote.Root
`ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

Fields inherited from interface com.sas.metadata.remote.MdObjectBase
`ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

Method Summary
`Root` | `getAssociatedObject()` Gets the `Root` for `AssociatedObject`
`AssociationList` | `getAssociatedObjects()` Gets the AssociationList of `AssociatedObjects`
`AssociationList` | `getAssociatedObjects(boolean fGoToServer)` Gets the Associationlist of `AssociatedObjects`
`java.lang.String` | `getMarker()` Gets the `String` value of `Marker`
`int` | `getMarkerMaxLength()` Gets the maximum length of `Marker`
`int` | `getMarkerState()` Gets the Metadata State of `Marker`
`AbstractTransformation` | `getOwningTransformation()` Gets the `AbstractTransformation` for `OwningTransformation`
`AssociationList` | `getOwningTransformations()` Gets the AssociationList of `OwningTransformations`
`AssociationList` | `getOwningTransformations(boolean fGoToServer)` Gets the Associationlist of `OwningTransformations`
`java.lang.String` | `getValueType()` Gets the `String` value of `ValueType`
`int` | `getValueTypeMaxLength()` Gets the maximum length of `ValueType`
`int` | `getValueTypeState()` Gets the Metadata State of `ValueType`
`void` | `initializePredObjects()` (S) Adds the Associated objects to the predObjects which are: `AssociatedObject` `OwningTransformation`
`void` | `initializeRequiredObjects()` (S) This initializes the Required Objects(Roles) which are: `OwningTransformation`
`void` | `setAssociatedObject(Root inObject)` Sets the `AssociatedObjects` list 0th element to be `inObject`.
`void` | `setAssociatedObjects(AssociationList list)` Sets the `AssociatedObjects` list to be `list`.
`void` | `setAssociatedObjects(AssociationList list, int state)` Sets the `AssociatedObjects` list to be `list`.
`void` | `setMarker(java.lang.String inMarker)` Sets the `Marker` value and sets the state to MetadataState.LOCAL.
`void` | `setMarker(java.lang.String inMarker, int state)` Sets the `Marker` Metadata State.
`void` | `setMarkerState(int state)` Sets the Metadata State of `Marker`.
`void` | `setOwningTransformation(AbstractTransformation inObject)` Sets the `OwningTransformations` list 0th element to be `inObject`.
`void` | `setOwningTransformations(AssociationList list)` Sets the `OwningTransformations` list to be `list`.
`void` | `setOwningTransformations(AssociationList list, int state)` Sets the `OwningTransformations` list to be `list`.
`void` | `setValueType(java.lang.String inValueType)` Sets the `ValueType` value and sets the state to MetadataState.LOCAL.
`void` | `setValueType(java.lang.String inValueType, int state)` Sets the `ValueType` Metadata State.
`void` | `setValueTypeState(int state)` Sets the Metadata State of `ValueType`.

Methods inherited from interface com.sas.metadata.remote.Root
`getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML
`closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil
`addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

Methods inherited from interface com.sas.metadata.remote.MdObjectBase
`addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

Field Detail

### ATTRIBUTE_MARKER_NAME

    static final java.lang.String ATTRIBUTE_MARKER_NAME

  Constant used for the name of the Marker attribute.

  Marker: The marker that needs to be replaced. This is the substitution string that should be replaced.

  See Also:
    Constant Field Values

### ATTRIBUTE_VALUETYPE_NAME

    static final java.lang.String ATTRIBUTE_VALUETYPE_NAME

  Constant used for the name of the ValueType attribute.

  ValueType: The type of the value to replace the marker with. May be used to specify the name of the attribute contained in the associated metadata object that should be used in the replacement.

  See Also:
    Constant Field Values

### ASSOCIATION_ASSOCIATEDOBJECT_NAME

    static final java.lang.String ASSOCIATION_ASSOCIATEDOBJECT_NAME

  Constant used for the name of the AssociatedObject association.

  AssociatedObject: The object that contains the substitution values.

  See Also:
    Constant Field Values

### ASSOCIATION_OWNINGTRANSFORMATION_NAME

    static final java.lang.String ASSOCIATION_OWNINGTRANSFORMATION_NAME

  Constant used for the name of the OwningTransformation association.

  OwningTransformation: The owning transformation for this variable.

  See Also:
    Constant Field Values

Method Detail

### initializeRequiredObjects

    void initializeRequiredObjects()
                                   throws java.rmi.RemoteException

  (S) This initializes the Required Objects(Roles) which are:
  `OwningTransformation`

  Specified by:
    `initializeRequiredObjects` in interface `MdObjectBaseUtil`
  Specified by:
    `initializeRequiredObjects` in interface `Root`
  Specified by:
    `initializeRequiredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### initializePredObjects

    void initializePredObjects()
                               throws java.rmi.RemoteException

  (S) Adds the Associated objects to the predObjects which are:
  `AssociatedObject`
  `OwningTransformation`

  Specified by:
    `initializePredObjects` in interface `MdObjectBase`
  Specified by:
    `initializePredObjects` in interface `Root`
  Specified by:
    `initializePredObjects` in interface `SecondaryType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getMarker

    java.lang.String getMarker()
                               throws java.rmi.RemoteException

  Gets the `String` value of `Marker`

  Returns:
    The `Marker`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getMarkerState

    int getMarkerState()
                       throws java.rmi.RemoteException

  Gets the Metadata State of `Marker`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getMarkerMaxLength

    int getMarkerMaxLength()
                           throws java.rmi.RemoteException

  Gets the maximum length of `Marker`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getValueType

    java.lang.String getValueType()
                                  throws java.rmi.RemoteException

  Gets the `String` value of `ValueType`

  Returns:
    The `ValueType`
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getValueTypeState

    int getValueTypeState()
                          throws java.rmi.RemoteException

  Gets the Metadata State of `ValueType`

  Returns:
    The State.
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getValueTypeMaxLength

    int getValueTypeMaxLength()
                              throws java.rmi.RemoteException

  Gets the maximum length of `ValueType`

  Returns:
    The max size
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.

### getAssociatedObjects

    AssociationList getAssociatedObjects()
                                         throws java.rmi.RemoteException,
                                                MdException

  Gets the AssociationList of `AssociatedObjects`

  Returns:
    Returns the AssociationList of `AssociatedObjects` which can be of type:
    All types
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException`

### getAssociatedObject

    Root getAssociatedObject()
                             throws java.rmi.RemoteException,
                                    MdException

  Gets the `Root` for `AssociatedObject`

  Returns:
    The `Root` ( `null` if not set) of `AssociatedObject`which can be of type:
    All types
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getOwningTransformations

    AssociationList getOwningTransformations()
                                             throws java.rmi.RemoteException,
                                                    MdException

  Gets the AssociationList of `OwningTransformations`

  Returns:
    Returns the AssociationList of `OwningTransformations` which can be of type:
    AbstractTransformation
    TransformationStep
    SyncStep
    TransformationActivity
    FeatureMap
    ColumnHierarchy
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException`

### getOwningTransformation

    AbstractTransformation getOwningTransformation()
                                                   throws java.rmi.RemoteException,
                                                          MdException

  Gets the `AbstractTransformation` for `OwningTransformation`

  Returns:
    The `AbstractTransformation` ( `null` if not set) of `OwningTransformation`which can be of type:
    AbstractTransformation
    TransformationStep
    SyncStep
    TransformationActivity
    FeatureMap
    ColumnHierarchy
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getAssociatedObjects

    AssociationList getAssociatedObjects(boolean fGoToServer)
                                         throws java.rmi.RemoteException,
                                                MdException

  Gets the Associationlist of `AssociatedObjects`

  Parameters:
    `fGoToServer` - boolean Get the value from the server.
  Returns:
    Returns the AssociationList of `AssociatedObjects` which can be of type:
    All types
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### getOwningTransformations

    AssociationList getOwningTransformations(boolean fGoToServer)
                                             throws java.rmi.RemoteException,
                                                    MdException

  Gets the Associationlist of `OwningTransformations`

  Parameters:
    `fGoToServer` - boolean Get the value from the server.
  Returns:
    Returns the AssociationList of `OwningTransformations` which can be of type:
    AbstractTransformation
    TransformationStep
    SyncStep
    TransformationActivity
    FeatureMap
    ColumnHierarchy
    Transformation
    ClassifierMap
    Select
    Join
    AbstractJob
    Job
    JFJob
    MiningResult
  Throws:
    `java.rmi.RemoteException` - If error connecting/communicating to/with remote object.
    `MdException` - If error getting/setting part of the object.

### setMarker

    void setMarker(java.lang.String inMarker)
                   throws java.rmi.RemoteException

  Sets the `Marker` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inMarker` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setMarker

    void setMarker(java.lang.String inMarker,
                   int state)
                   throws java.rmi.RemoteException

  Sets the `Marker` Metadata State.

  Parameters:
    `inMarker` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setMarkerState

    void setMarkerState(int state)
                        throws java.rmi.RemoteException

  Sets the Metadata State of `Marker`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setValueType

    void setValueType(java.lang.String inValueType)
                      throws java.rmi.RemoteException

  Sets the `ValueType` value and sets the state to MetadataState.LOCAL.

  Parameters:
    `inValueType` - String
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setValueType

    void setValueType(java.lang.String inValueType,
                      int state)
                      throws java.rmi.RemoteException

  Sets the `ValueType` Metadata State.

  Parameters:
    `inValueType` - String
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setValueTypeState

    void setValueTypeState(int state)
                           throws java.rmi.RemoteException

  Sets the Metadata State of `ValueType`.

  Parameters:
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setAssociatedObjects

    void setAssociatedObjects(AssociationList list)
                              throws java.rmi.RemoteException

  Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
  All types

  Parameters:
    `list` - AssociationList
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setAssociatedObjects

    void setAssociatedObjects(AssociationList list,
                              int state)
                              throws java.rmi.RemoteException

  Sets the `AssociatedObjects` list to be `list`. Object of which can be of type:
  All types

  Parameters:
    `list` - AssociationList
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setAssociatedObject

    void setAssociatedObject(Root inObject)
                             throws java.rmi.RemoteException

  Sets the `AssociatedObjects` list 0th element to be `inObject`.

  Parameters:
    `inObject` - Root
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setOwningTransformations

    void setOwningTransformations(AssociationList list)
                                  throws java.rmi.RemoteException

  Sets the `OwningTransformations` list to be `list`. Object of which can be of type:
  AbstractTransformation
  TransformationStep
  SyncStep
  TransformationActivity
  FeatureMap
  ColumnHierarchy
  Transformation
  ClassifierMap
  Select
  Join
  AbstractJob
  Job
  JFJob
  MiningResult

  Parameters:
    `list` - AssociationList
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setOwningTransformations

    void setOwningTransformations(AssociationList list,
                                  int state)
                                  throws java.rmi.RemoteException

  Sets the `OwningTransformations` list to be `list`. Object of which can be of type:
  AbstractTransformation
  TransformationStep
  SyncStep
  TransformationActivity
  FeatureMap
  ColumnHierarchy
  Transformation
  ClassifierMap
  Select
  Join
  AbstractJob
  Job
  JFJob
  MiningResult

  Parameters:
    `list` - AssociationList
    `state` - int
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

### setOwningTransformation

    void setOwningTransformation(AbstractTransformation inObject)
                                 throws java.rmi.RemoteException

  Sets the `OwningTransformations` list 0th element to be `inObject`.

  Parameters:
    `inObject` - AbstractTransformation
  Throws:
    `java.rmi.RemoteException` - If error communicating with remote object.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Metadata |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.